public class BeatBox.PageSwitcher : VBox {
	VBox tabs;
	Notebook content;
	
	public int page {
		get { return content.page; }
		set {
			set_current_page(value);
		}
	}
	
	public PageSwitcher() {
		tabs = new VBox(true, 0);
		content = new Notebook();
		
		content.show_tabs = false;
		
	}
	
	public int append (string label, Widget w) {
		var button = new ModeButtonItem ();

		button.add (w);

		button.button_press_event.connect (() => {
			int selected = get_children().index (button);
			set_active (selected);
			return true;
		});

		add (button);
		button.show_all ();

		int item_index = (int)get_children ().length ();
		mode_added (item_index, w); // Emit the added signal
		return item_index;
	}
	
	public int remove(int index) {
		tabs.get_children().nth_data(index).destroy();
		content.remove_page(index);
		if(index == page && content.get_n_pages() > 0) {
			set_current_page(0);
		}
	}
	
	void set_current_page(int index) {
		if(index < 0 || index >= tabs.get_children().length()) {
			warning("Tried to select page that is out of bounds\n");
			return;
		}
		
		// Update selected button
		for(int i = 0; i < tabs.get_children().length(); ++i) {
			var toggle = (ToggleButton)tabs.get_children().nth_data(i);
			toggle.set_active(index == i);
		}
		
		// Update content
		content.page = index;
	}
}
